#include "KartenLeser.h"
#include <Datei.h>
#include "AccountHistorieDaten.h"
#include <Klient.h>

// Inhalt der KartenLeser Klasse aus KartenLeser.h
// Konstruktor 
KartenLeser::KartenLeser( int karteId, InformationServer *is )
{
	pfad = new Text( "" );
    *pfad += karteId;
    while( DateiExistiert( pfad->getText() ) )
        pfad->anhngen( "_" );
    ref = 1;
    Text ip;
    int port;
    is->zDB()->getKartenServerPortIp( 0, karteId, &port, &ip );
    Klient *klient = new Klient();
    unsigned char schlssel[ 20 ] = { 24, 15, 53, 87, 38, 73, 154, 38, 246, 90, 39, 133, 11, 199, 22, 80, 26, 132, 95, 54 };
    klient->setSendeSchlssel( (char*)schlssel, 20 );
    klient->setEmpfangSchlssel( (char*)schlssel, 20 );
    if( !klient->verbinde( (unsigned short)port, ip ) )
    {
        klient = klient->release();
        return;
    }
    klient->sendeVerschlsselt( "\x7", 1 );
    char ret = 0;
    klient->getNachrichtVerschlsselt( &ret, 1 );
    if( ret == 1 )
    {
        klient->sendeVerschlsselt( (char*)&karteId, 4 );
        klient->getNachrichtVerschlsselt( &ret, 1 );
        if( ret == 1 )
        {
            int anz = 0;
            klient->getNachrichtVerschlsselt( (char*)&anz, 4 );
            for( int i = 0; i < anz; i++ )
            {
                char ln = 0;
                klient->getNachrichtVerschlsselt( &ln, 1 );
                if( !ln )
                    continue;
                char *pfa = new char[ ln + 1 ];
                pfa[ ln ] = 0;
                klient->getNachrichtVerschlsselt( pfa, ln );
                __int64 gre = 0;
                klient->getNachrichtVerschlsselt( (char*)&gre, 8 );
                char *buffer = new char[ 2048 ];
                Text pf = pfad->getText();
                pf += "/";
                pf += pfa;
                delete[] pfa;
                Datei d;
                d.setDatei( pf );
                d.erstellen();
                d.ffnen( Datei::Style::schreiben );
                while( gre )
                {
                    int l = gre >= 2048 ? 2048 : (int)gre;
                    klient->getNachricht( buffer, l );
                    d.schreibe( buffer, l );
                    gre -= l;
                }
                d.schlieen();
                delete[] buffer;
            }
        }
    }
    if( ret == 3 )
    {
        char byte = 0;
        klient->getNachrichtVerschlsselt( &byte, 1 );
        char *f = new char[ byte + 1 ];
        f[ byte ] = 0;
        klient->getNachrichtVerschlsselt( f, byte );
        delete[] f;
    }
    klient->sendeVerschlsselt( "\3", 1 );
    klient->getNachrichtVerschlsselt( &ret, 1 );
    klient->trenne();
    klient->release();
}

// Destruktor
KartenLeser::~KartenLeser()
{
    DateiLschen( pfad );
}

// nicht constant
bool KartenLeser::ladeSpielerTeamStruktur( SpielerTeamStruktur *sts )
{
	if( !pfad->getLnge() )
		return 0;
	Text *pf = new Text( pfad->getText() );
	pf->anhngen( "/sts.ltgd" );
	Datei *datei = new Datei();
	datei->setDatei( pf );
	if( !datei->existiert() || datei->istOrdner() )
	{
		datei->release();
		return 0;
	}
	datei->ffnen( Datei::Style::lesen );
	datei->lese( (char*)&sts->spielerAnzahl, 4 );
	datei->lese( (char*)&sts->teamAnzahl, 4 );
	if( sts->spielerFarbe )
		sts->spielerFarbe->release();
	sts->spielerFarbe = new Array< int >();
	for( int i = 0; i < sts->spielerAnzahl; i++ )
	{
		int farbe = 0;
		datei->lese( (char*)&farbe, 4 );
		sts->spielerFarbe->set( farbe, i );
	}
	if( sts->teamFarbe )
		sts->teamFarbe->release();
	sts->teamFarbe = new Array< int >();
	for( int i = 0; i < sts->teamAnzahl; i++ )
	{
		int farbe = 0;
		datei->lese( (char*)&farbe, 4 );
		sts->teamFarbe->set( farbe, i );
	}
	if( sts->teamName )
		sts->teamName->release();
	sts->teamName = new RCArray< Text >();
	for( int i = 0; i < sts->teamAnzahl; i++ )
	{
		char ln = 0;
		datei->lese( &ln, 1 );
		char *txt = new char[ ln + 1 ];
		txt[ ln ] = 0;
		datei->lese( txt, ln );
		Text *name = new Text( txt );
		delete[] txt;
		sts->teamName->set( name, i );
	}
	if( sts->teamGre )
		sts->teamGre->release();
	sts->teamGre = new Array< int >();
	for( int i = 0; i < sts->teamAnzahl; i++ )
	{
		int gre = 0;
		datei->lese( (char*)&gre, 4 );
		sts->teamGre->set( gre, i );
	}
	datei->schlieen();
	datei->release();
	return 1;
}

// constant
Text *KartenLeser::getPfad() const
{
	return pfad ? pfad->getThis() : 0;
}

Text *KartenLeser::zPfad() const
{
	return pfad;
}

// Reference Counting
KartenLeser *KartenLeser::getThis()
{
	ref++;
	return this;
}

KartenLeser *KartenLeser::release()
{
	ref--;
	if( !ref )
		delete this;
	return 0;
}